diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/txop.h ns-3.31/src/wifi/model/txop.h
--- ns-3.30.1/src/wifi/model/txop.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/txop.h	2020-06-27 17:38:30.000000000 -0700
@@ -37,6 +37,7 @@
 class UniformRandomVariable;
 class CtrlBAckResponseHeader;
 class WifiRemoteStationManager;
+class WifiTxVector;
 
 /**
  * \brief Handle packet fragmentation and retransmissions
@@ -56,17 +57,15 @@
  *
  * The retransmission policy is also very simple: every packet is
  * retransmitted until it is either successfully transmitted or
- * it has been retransmitted up until the ssrc or slrc thresholds.
+ * it has been retransmitted up until the SSRC or SLRC thresholds.
  *
- * The rts/cts policy is similar to the fragmentation policy: when
- * a packet is bigger than a threshold, the rts/cts protocol is used.
+ * The RTS/CTS policy is similar to the fragmentation policy: when
+ * a packet is bigger than a threshold, the RTS/CTS protocol is used.
  */
 
 class Txop : public Object
 {
 public:
-  /// allow DcfListener class access
-  friend class DcfListener;
   /// allow MacLowTransmissionListener class access
   friend class MacLowTransmissionListener;
 
@@ -105,25 +104,25 @@
   /**
    * Set MacLow associated with this Txop.
    *
-   * \param low MacLow.
+   * \param low MacLow to associate.
    */
   void SetMacLow (const Ptr<MacLow> low);
   /**
    * Set ChannelAccessManager this Txop is associated to.
    *
-   * \param manager ChannelAccessManager.
+   * \param manager ChannelAccessManager to associate.
    */
   void SetChannelAccessManager (const Ptr<ChannelAccessManager> manager);
   /**
    * Set WifiRemoteStationsManager this Txop is associated to.
    *
-   * \param remoteManager WifiRemoteStationManager.
+   * \param remoteManager WifiRemoteStationManager to associate.
    */
   virtual void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> remoteManager);
   /**
    * Set MacTxMiddle this Txop is associated to.
    *
-   * \param txMiddle MacTxMiddle.
+   * \param txMiddle MacTxMiddle to associate.
    */
   void SetTxMiddle (const Ptr<MacTxMiddle> txMiddle);
 
@@ -134,26 +133,26 @@
   void SetTxOkCallback (TxOk callback);
   /**
    * \param callback the callback to invoke when a
-   * packet transmission was completed unsuccessfully.
+   *        packet transmission was completed unsuccessfully.
    */
   void SetTxFailedCallback (TxFailed callback);
   /**
    * \param callback the callback to invoke when a
-   * packet is dropped.
+   *        packet is dropped.
    */
   void SetTxDroppedCallback (TxDropped callback);
 
   /**
    * Return the MacLow associated with this Txop.
    *
-   * \return MacLow
+   * \return the associated MacLow
    */
   Ptr<MacLow> GetLow (void) const;
 
   /**
    * Return the packet queue associated with this Txop.
    *
-   * \return WifiMacQueue
+   * \return the associated WifiMacQueue
    */
   Ptr<WifiMacQueue > GetWifiMacQueue () const;
 
@@ -179,7 +178,7 @@
    * Set the TXOP limit.
    *
    * \param txopLimit the TXOP limit.
-   * Value zero corresponds to default DCF.
+   *        Value zero corresponds to default Txop.
    */
   void SetTxopLimit (Time txopLimit);
   /**
@@ -237,10 +236,10 @@
    * Store the packet in the internal queue until it
    * can be sent safely.
    */
-  virtual void Queue (Ptr<const Packet> packet, const WifiMacHeader &hdr);
+  virtual void Queue (Ptr<Packet> packet, const WifiMacHeader &hdr);
 
   /**
-   * Sends CF frame to sta with address <i>addr</i>.
+   * Sends CF frame to STA with address <i>addr</i>.
    *
    * \param frameType the type of frame to be transmitted.
    * \param addr address of the recipient.
@@ -253,11 +252,11 @@
    */
   virtual void MissedCts (void);
   /**
-   * Event handler when an ACK is received.
+   * Event handler when an Ack is received.
    */
   virtual void GotAck (void);
   /**
-   * Event handler when an ACK is missed.
+   * Event handler when an Ack is missed.
    */
   virtual void MissedAck (void);
   /**
@@ -267,22 +266,23 @@
   /**
    * Event handler when a response to a CF-POLL frame is missed.
    *
-   * \param expectedCfAck flag to indicate whether a CF-ACK was expected in the response.
+   * \param expectedCfAck flag to indicate whether a CF-Ack was expected in the response.
    */
   void MissedCfPollResponse (bool expectedCfAck);
   /**
-   * Event handler when a Block ACK is received.
+   * Event handler when a BlockAck is received.
    *
-   * \param blockAck block ack.
+   * \param blockAck BlockAck header.
    * \param recipient address of the recipient.
-   * \param rxSnr SNR of the block ack itself.
-   * \param txMode wifi mode.
-   * \param dataSnr reported data SNR from the peer.
+   * \param rxSnr SNR of the BlockAck itself in linear scale.
+   * \param dataSnr reported data SNR from the peer in linear scale.
+   * \param dataTxVector TXVECTOR used to send the Data.
    */
-  virtual void GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient, double rxSnr, WifiMode txMode, double dataSnr);
+  virtual void GotBlockAck (const CtrlBAckResponseHeader *blockAck, Mac48Address recipient,
+                            double rxSnr, double dataSnr, WifiTxVector dataTxVector);
   /**
-   * Event handler when a Block ACK timeout has occurred.
-   * \param nMpdus the number of MPDUs sent in the A-MPDU transmission that results in a Block ACK timeout.
+   * Event handler when a BlockAck timeout has occurred.
+   * \param nMpdus the number of MPDUs sent in the A-MPDU transmission that results in a BlockAck timeout.
    */
   virtual void MissedBlockAck (uint8_t nMpdus);
 
@@ -301,7 +301,7 @@
   virtual void StartNextPacket (void);
   /**
    * Event handler when a transmission that
-   * does not require an ACK has completed.
+   * does not require an Ack has completed.
    */
   virtual void EndTxNoAck (void);
 
@@ -357,36 +357,41 @@
   virtual void DoDispose (void);
   virtual void DoInitialize (void);
 
-  /* dcf notifications forwarded here */
+  /* Txop notifications forwarded here */
   /**
    * Notify that access request has been received.
    */
   virtual void NotifyAccessRequested (void);
   /**
-   * Notify the DCF that access has been granted.
+   * Notify the Txop that access has been granted.
    */
   virtual void NotifyAccessGranted (void);
   /**
-   * Notify the DCF that internal collision has occurred.
+   * Notify the Txop that internal collision has occurred.
    */
   virtual void NotifyInternalCollision (void);
+
   /**
-   * Notify the DCF that collision has occurred.
+   * Check if the Txop has frames to transmit.
+   * \return true if the Txop has frames to transmit.
    */
-  virtual void NotifyCollision (void);
-
+  virtual bool HasFramesToTransmit (void);
+  /**
+   * Generate a new backoff now.
+   */
+  virtual void GenerateBackoff (void);
   /**
    * Restart access request if needed.
    */
   virtual void RestartAccessIfNeeded (void);
   /**
-   * Request access from DCF manager if needed.
+   * Request access from Txop if needed.
    */
   virtual void StartAccessIfNeeded (void);
 
   /**
    * \returns the current value of the CW variable. The initial value is
-   * minCW.
+   *          minCW.
    */
   uint32_t GetCw (void) const;
   /**
@@ -417,8 +422,8 @@
   /**
    * Update backoff slots that nSlots has passed.
    *
-   * \param nSlots
-   * \param backoffUpdateBound
+   * \param nSlots the number of slots to decrement
+   * \param backoffUpdateBound the time at which backoff should start
    */
   void UpdateBackoffSlotsNow (uint32_t nSlots, Time backoffUpdateBound);
 
@@ -432,11 +437,11 @@
    */
   bool NeedRtsRetransmission (Ptr<const Packet> packet, const WifiMacHeader &hdr);
   /**
-   * Check if DATA should be re-transmitted if ACK was missed.
+   * Check if Data should be re-transmitted if Ack was missed.
    *
    * \param packet current packet being transmitted.
    * \param hdr current header being transmitted.
-   * \return true if DATA should be re-transmitted,
+   * \return true if Data should be re-transmitted,
    *         false otherwise.
    */
   bool NeedDataRetransmission (Ptr<const Packet> packet, const WifiMacHeader &hdr);
@@ -466,19 +471,19 @@
   /**
    * Calculate the size of the next fragment.
    *
-   * \return the size of the next fragment.
+   * \return the size of the next fragment in bytes.
    */
   virtual uint32_t GetNextFragmentSize (void) const;
   /**
    * Calculate the size of the current fragment.
    *
-   * \return the size of the current fragment.
+   * \return the size of the current fragment in bytes.
    */
   virtual uint32_t GetFragmentSize (void) const;
   /**
    * Calculate the offset for the current fragment.
    *
-   * \return the offset for the current fragment.
+   * \return the offset for the current fragment in bytes.
    */
   virtual uint32_t GetFragmentOffset (void) const;
   /**
@@ -498,21 +503,21 @@
   void TxDroppedPacket (Ptr<const WifiMacQueueItem> item);
 
   Ptr<ChannelAccessManager> m_channelAccessManager; //!< the channel access manager
-  TxOk m_txOkCallback; //!< the transmit OK callback
-  TxFailed m_txFailedCallback; //!< the transmit failed callback
-  TxDropped m_txDroppedCallback; //!< the packet dropped callback
-  Ptr<WifiMacQueue> m_queue; //!< the wifi MAC queue
-  Ptr<MacTxMiddle> m_txMiddle; //!< the MacTxMiddle
-  Ptr <MacLow> m_low; //!< the MacLow
-  Ptr<WifiRemoteStationManager> m_stationManager; //!< the wifi remote station manager
-  Ptr<UniformRandomVariable> m_rng; //!<  the random stream
-
-  uint32_t m_cwMin;       //!< the CW minimum
-  uint32_t m_cwMax;       //!< the CW maximum
-  uint32_t m_cw;          //!< the current CW
-  uint32_t m_backoff;     //!< the current backoff
-  bool m_accessRequested; //!< flag whether channel access is already requested
-  uint32_t m_backoffSlots; //!< the backoff slots
+  TxOk m_txOkCallback;                              //!< the transmit OK callback
+  TxFailed m_txFailedCallback;                      //!< the transmit failed callback
+  TxDropped m_txDroppedCallback;                    //!< the packet dropped callback
+  Ptr<WifiMacQueue> m_queue;                        //!< the wifi MAC queue
+  Ptr<MacTxMiddle> m_txMiddle;                      //!< the MacTxMiddle
+  Ptr <MacLow> m_low;                               //!< the MacLow
+  Ptr<WifiRemoteStationManager> m_stationManager;   //!< the wifi remote station manager
+  Ptr<UniformRandomVariable> m_rng;                 //!< the random stream
+
+  uint32_t m_cwMin;        //!< the minimum contention window
+  uint32_t m_cwMax;        //!< the maximum contention window
+  uint32_t m_cw;           //!< the current contention window
+  uint32_t m_backoff;      //!< the current backoff
+  bool m_accessRequested;  //!< flag whether channel access is already requested
+  uint32_t m_backoffSlots; //!< the number of backoff slots
   /**
    * the backoffStart variable is used to keep track of the
    * time at which a backoff was started or the time at which
@@ -521,14 +526,14 @@
   Time m_backoffStart;
 
   uint8_t m_aifsn;        //!< the AIFSN
-  Time m_txopLimit;       //!< the txop limit time
+  Time m_txopLimit;       //!< the TXOP limit time
 
-  Ptr<const Packet> m_currentPacket; //!< the current packet
-  WifiMacHeader m_currentHdr; //!< the current header
-  MacLowTransmissionParameters m_currentParams; ///< current transmission parameters
-  uint8_t m_fragmentNumber; //!< the fragment number
-  TracedCallback<uint32_t> m_backoffTrace; //!< backoff trace value
-  TracedValue<uint32_t> m_cwTrace;         //!< CW trace value
+  Ptr<const Packet> m_currentPacket;            //!< the current packet
+  WifiMacHeader m_currentHdr;                   //!< the current header
+  MacLowTransmissionParameters m_currentParams; //!< current transmission parameters
+  uint8_t m_fragmentNumber;                     //!< the fragment number
+  TracedCallback<uint32_t> m_backoffTrace;      //!< backoff trace value
+  TracedValue<uint32_t> m_cwTrace;              //!< CW trace value
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/vht-capabilities.cc ns-3.31/src/wifi/model/vht-capabilities.cc
--- ns-3.30.1/src/wifi/model/vht-capabilities.cc	2019-09-18 10:36:11.000000000 -0700
+++ ns-3.31/src/wifi/model/vht-capabilities.cc	2020-06-27 17:38:30.000000000 -0700
@@ -63,9 +63,9 @@
 }
 
 void
-VhtCapabilities::SetVhtSupported (uint8_t vhtsupported)
+VhtCapabilities::SetVhtSupported (uint8_t vhtSupported)
 {
-  m_vhtSupported = vhtsupported;
+  m_vhtSupported = vhtSupported;
 }
 
 uint8_t
@@ -227,39 +227,39 @@
 }
 
 void
-VhtCapabilities::SetSupportedChannelWidthSet (uint8_t channelwidthset)
+VhtCapabilities::SetSupportedChannelWidthSet (uint8_t channelWidthSet)
 {
-  m_supportedChannelWidthSet = channelwidthset;
+  m_supportedChannelWidthSet = channelWidthSet;
 }
 
 void
-VhtCapabilities::SetRxLdpc (uint8_t rxldpc)
+VhtCapabilities::SetRxLdpc (uint8_t rxLdpc)
 {
-  m_rxLdpc = rxldpc;
+  m_rxLdpc = rxLdpc;
 }
 
 void
-VhtCapabilities::SetShortGuardIntervalFor80Mhz (uint8_t shortguardinterval)
+VhtCapabilities::SetShortGuardIntervalFor80Mhz (uint8_t shortGuardInterval)
 {
-  m_shortGuardIntervalFor80Mhz = shortguardinterval;
+  m_shortGuardIntervalFor80Mhz = shortGuardInterval;
 }
 
 void
-VhtCapabilities::SetShortGuardIntervalFor160Mhz (uint8_t shortguardinterval)
+VhtCapabilities::SetShortGuardIntervalFor160Mhz (uint8_t shortGuardInterval)
 {
-  m_shortGuardIntervalFor160Mhz = shortguardinterval;
+  m_shortGuardIntervalFor160Mhz = shortGuardInterval;
 }
 
 void
-VhtCapabilities::SetRxStbc (uint8_t rxstbc)
+VhtCapabilities::SetRxStbc (uint8_t rxStbc)
 {
-  m_rxStbc = rxstbc;
+  m_rxStbc = rxStbc;
 }
 
 void
-VhtCapabilities::SetTxStbc (uint8_t txstbc)
+VhtCapabilities::SetTxStbc (uint8_t txStbc)
 {
-  m_txStbc = txstbc;
+  m_txStbc = txStbc;
 }
 
 void
@@ -331,15 +331,15 @@
 }
 
 void
-VhtCapabilities::SetRxHighestSupportedLgiDataRate (uint16_t supporteddatarate)
+VhtCapabilities::SetRxHighestSupportedLgiDataRate (uint16_t supportedDatarate)
 {
-  m_rxHighestSupportedLongGuardIntervalDataRate = supporteddatarate;
+  m_rxHighestSupportedLongGuardIntervalDataRate = supportedDatarate;
 }
 
 void
-VhtCapabilities::SetTxHighestSupportedLgiDataRate (uint16_t supporteddatarate)
+VhtCapabilities::SetTxHighestSupportedLgiDataRate (uint16_t supportedDatarate)
 {
-  m_txHighestSupportedLongGuardIntervalDataRate = supporteddatarate;
+  m_txHighestSupportedLongGuardIntervalDataRate = supportedDatarate;
 }
 
 uint16_t
@@ -415,14 +415,6 @@
   return m_rxHighestSupportedLongGuardIntervalDataRate;
 }
 
-/**
- * output stream output operator
- *
- * \param os output stream
- * \param VhtCapabilities the VHT capabilities
- *
- * \returns output stream
- */
 std::ostream &
 operator << (std::ostream &os, const VhtCapabilities &VhtCapabilities)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/vht-capabilities.h ns-3.31/src/wifi/model/vht-capabilities.h
--- ns-3.30.1/src/wifi/model/vht-capabilities.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/vht-capabilities.h	2020-06-27 17:38:30.000000000 -0700
@@ -35,39 +35,25 @@
 {
 public:
   VhtCapabilities ();
-  /**
-   * Set the VHT supported field.
-   *
-   * \param vhtsupported the VHT supported field
-   */
-  void SetVhtSupported (uint8_t vhtsupported);
 
-  /**
-   * Return the element ID.
-   *
-   * \returns the wifi information element ID
-   */
+  // Implementations of pure virtual methods of WifiInformationElement
   WifiInformationElementId ElementId () const;
-  /**
-   * Return the information field size.
-   *
-   * \returns the information field size
-   */
   uint8_t GetInformationFieldSize () const;
-  /**
-   * Serialize the information field.
-   *
-   * \param start the information field iterator
-   */
   void SerializeInformationField (Buffer::Iterator start) const;
+  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length);
+  /* This information element is a bit special in that it is only
+     included if the STA is an VHT STA. To support this we
+     override the Serialize and GetSerializedSize methods of
+     WifiInformationElement. */
+  Buffer::Iterator Serialize (Buffer::Iterator start) const;
+  uint16_t GetSerializedSize () const;
+
   /**
-   * Deserialize the information field.
+   * Set the VHT supported field.
    *
-   * \param start the information field iterator
-   * \param length the information field
-   * \returns the information field
+   * \param vhtSupported the VHT supported field
    */
-  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length);
+  void SetVhtSupported (uint8_t vhtSupported);
 
   /**
    * Set the VHT Capabilities Info field in the VHT Capabilities information element.
@@ -105,56 +91,56 @@
   /**
    * Set the supported channel width set.
    *
-   * \param channelwidthset the supported channel width set
+   * \param channelWidthSet the supported channel width set
    */
-  void SetSupportedChannelWidthSet (uint8_t channelwidthset);
+  void SetSupportedChannelWidthSet (uint8_t channelWidthSet);
   /**
    * Set the receive LDPC.
    *
-   * \param rxldpc the receive LDPC
+   * \param rxLdpc the receive LDPC
    */
-  void SetRxLdpc (uint8_t rxldpc);
+  void SetRxLdpc (uint8_t rxLdpc);
   /**
-   * Set the short guard interval 80 Mhz.
+   * Set the short guard interval 80 MHz.
    *
-   * \param shortguardinterval the short guard interval 80 Mhz
+   * \param shortGuardInterval the short guard interval 80 MHz
    */
-  void SetShortGuardIntervalFor80Mhz (uint8_t shortguardinterval);
+  void SetShortGuardIntervalFor80Mhz (uint8_t shortGuardInterval);
   /**
-   * Set the short guard interval 160 Mhz.
+   * Set the short guard interval 160 MHz.
    *
-   * \param shortguardinterval the short guard interval 160 Mhz
+   * \param shortGuardInterval the short guard interval 160 MHz
    */
-  void SetShortGuardIntervalFor160Mhz (uint8_t shortguardinterval);
+  void SetShortGuardIntervalFor160Mhz (uint8_t shortGuardInterval);
   /**
    * Set the receive STBC.
    *
-   * \param rxstbc the receive STBC
+   * \param rxStbc the receive STBC
    */
-  void SetRxStbc (uint8_t rxstbc);
+  void SetRxStbc (uint8_t rxStbc);
   /**
    * Set the transmit STBC.
    *
-   * \param txstbc the receive STBC
+   * \param txStbc the receive STBC
    */
-  void SetTxStbc (uint8_t txstbc);
+  void SetTxStbc (uint8_t txStbc);
   /**
    * Set the maximum AMPDU length.
    *
-   * \param maxampdulength 2^(13 + x) - 1, x in the range 0 to 7
+   * \param maxAmpduLength 2^(13 + x) - 1, x in the range 0 to 7
    */
-  void SetMaxAmpduLength (uint32_t maxampdulength);
+  void SetMaxAmpduLength (uint32_t maxAmpduLength);
 
   /**
    * Get the maximum MPDU length.
    *
-   * \return the maximum MPDU length
+   * \return the maximum MPDU length in bytes
    */
   uint16_t GetMaxMpduLength (void) const;
   /**
    * Get the supported channel width set.
    *
-   * \returns the maximum MPDU length
+   * \returns the supported channel width set
    */
   uint8_t GetSupportedChannelWidthSet () const;
   /**
@@ -189,23 +175,23 @@
   /**
    * Set the receive highest supported LGI data rate.
    *
-   * \param supporteddatarate receive highest supported LGI data rate
+   * \param supportedDatarate receive highest supported LGI data rate
    */
-  void SetRxHighestSupportedLgiDataRate (uint16_t supporteddatarate);
+  void SetRxHighestSupportedLgiDataRate (uint16_t supportedDatarate);
   /**
    * Set the transmit highest supported LGI data rate.
    *
-   * \param supporteddatarate transmit highest supported LGI data rate
+   * \param supportedDatarate transmit highest supported LGI data rate
    */
-  void SetTxHighestSupportedLgiDataRate (uint16_t supporteddatarate);
+  void SetTxHighestSupportedLgiDataRate (uint16_t supportedDatarate);
   /**
    * Get the is MCS supported.
    *
    * \param mcs the MCS
-   * \param Nss the NSS
+   * \param nss the NSS
    * \returns the is MCS supported
    */
-  bool IsSupportedMcs (uint8_t mcs, uint8_t Nss) const;
+  bool IsSupportedMcs (uint8_t mcs, uint8_t nss) const;
 
   /**
    * Get the receive highest supported LGI data rate.
@@ -215,77 +201,68 @@
   uint16_t GetRxHighestSupportedLgiDataRate () const;
 
   /**
-   * Get the is transmit MCS supported.
+   * Returns true if transmit MCS is supported.
    *
    * \param mcs the MCS
-   * \returns is transmit MCS supported
+   * \returns whether transmit MCS is supported
    */
   bool IsSupportedTxMcs (uint8_t mcs) const;
   /**
-   * Get the is receive MCS supported.
+   * Returns true if receive MCS is supported.
    *
    * \param mcs the MCS
-   * \returns is receive MCS supported
+   * \returns whether receive MCS is supported
    */
   bool IsSupportedRxMcs (uint8_t mcs) const;
 
   /**
    * Return the maximum A-MPDU length.
    *
-   * \return the maximum A-MPDU length
+   * \return the maximum A-MPDU length in bytes
    */
   uint32_t GetMaxAmpduLength (void) const;
 
-  /**
-   * This information element is a bit special in that it is only
-   * included if the STA is an VHT STA. To support this we
-   * override the Serialize and GetSerializedSize methods of
-   * WifiInformationElement.
-   *
-   * \param start the iterator
-   * \returns the serialized size
-   */
-  Buffer::Iterator Serialize (Buffer::Iterator start) const;
-  /**
-   * Get the serialized size.
-   *
-   * \returns the serialized size
-   */
-  uint16_t GetSerializedSize () const;
-
 
 private:
   //Capabilities Info fields
-  uint8_t m_maxMpduLength; ///< maximum MPDU length
-  uint8_t m_supportedChannelWidthSet; ///< supported channel width set
-  uint8_t m_rxLdpc; ///< receive LDPC
-  uint8_t m_shortGuardIntervalFor80Mhz; ///< short guard interval 80 MHz
-  uint8_t m_shortGuardIntervalFor160Mhz;  ///< short guard interval 160 MHz
-  uint8_t m_txStbc; ///< transmit STBC
-  uint8_t m_rxStbc; ///< receive STBC
-  uint8_t m_suBeamformerCapable; ///< SU beam former capable
-  uint8_t m_suBeamformeeCapable; ///< SU beam formee capable
-  uint8_t m_beamformeeStsCapable; ///< beam formee STS capable
-  uint8_t m_numberOfSoundingDimensions; ///< number of sounding dimensions
-  uint8_t m_muBeamformerCapable; ///< MU beam former capable
-  uint8_t m_muBeamformeeCapable; ///< MU beam formee capable
-  uint8_t m_vhtTxopPs; ///< VHT TXOP PS
-  uint8_t m_htcVhtCapable; ///< HTC VHT capable
-  uint8_t m_maxAmpduLengthExponent; ///< maximum AMPDU length exponent
-  uint8_t m_vhtLinkAdaptationCapable; ///< VHT link adaptation capable
+  uint8_t m_maxMpduLength;               ///< maximum MPDU length
+  uint8_t m_supportedChannelWidthSet;    ///< supported channel width set
+  uint8_t m_rxLdpc;                      ///< receive LDPC
+  uint8_t m_shortGuardIntervalFor80Mhz;  ///< short guard interval for 80 MHz
+  uint8_t m_shortGuardIntervalFor160Mhz; ///< short guard interval for 160 MHz
+  uint8_t m_txStbc;                      ///< transmit STBC
+  uint8_t m_rxStbc;                      ///< receive STBC
+  uint8_t m_suBeamformerCapable;         ///< SU beamformer capable
+  uint8_t m_suBeamformeeCapable;         ///< SU beamformee capable
+  uint8_t m_beamformeeStsCapable;        ///< beamformee STS capable
+  uint8_t m_numberOfSoundingDimensions;  ///< number of sounding dimensions
+  uint8_t m_muBeamformerCapable;         ///< MU beamformer capable
+  uint8_t m_muBeamformeeCapable;         ///< MU beamformee capable
+  uint8_t m_vhtTxopPs;                   ///< VHT TXOP PS
+  uint8_t m_htcVhtCapable;               ///< HTC VHT capable
+  uint8_t m_maxAmpduLengthExponent;      ///< maximum A-MPDU length exponent
+  uint8_t m_vhtLinkAdaptationCapable;    ///< VHT link adaptation capable
   uint8_t m_rxAntennaPatternConsistency; ///< receive antenna pattern consistency
   uint8_t m_txAntennaPatternConsistency; ///< transmit antenna pattern consistency
 
   //MCS and NSS field information
-  std::vector<uint8_t> m_rxMcsMap; ///< receive MCS map
+  std::vector<uint8_t> m_rxMcsMap;                        ///< receive MCS map
   uint16_t m_rxHighestSupportedLongGuardIntervalDataRate; ///< receive highest supported long guard interval data rate
-  std::vector<uint8_t> m_txMcsMap; ///< transmit MCS map
-  uint16_t m_txHighestSupportedLongGuardIntervalDataRate;  ///< transmit highest supported long guard interval data rate
+  std::vector<uint8_t> m_txMcsMap;                        ///< transmit MCS map
+  uint16_t m_txHighestSupportedLongGuardIntervalDataRate; ///< transmit highest supported long guard interval data rate
 
   /// This is used to decide if this element should be added to the frame or not
   uint8_t m_vhtSupported;
 };
 
+/**
+ * output stream output operator
+ *
+ * \param os the output stream
+ * \param VhtCapabilities the VHT capabilities
+ *
+ * \returns output stream
+ */
 std::ostream &operator << (std::ostream &os, const VhtCapabilities &vhtcapabilities);
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/vht-configuration.cc ns-3.31/src/wifi/model/vht-configuration.cc
--- ns-3.30.1/src/wifi/model/vht-configuration.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/vht-configuration.cc	2020-06-27 17:38:30.000000000 -0700
@@ -19,7 +19,6 @@
  */
 
 #include "ns3/log.h"
-#include "ns3/uinteger.h"
 #include "vht-configuration.h"
 
 namespace ns3 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/vht-configuration.h ns-3.31/src/wifi/model/vht-configuration.h
--- ns-3.30.1/src/wifi/model/vht-configuration.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/vht-configuration.h	2020-06-27 17:38:30.000000000 -0700
@@ -39,6 +39,10 @@
   VhtConfiguration ();
   virtual ~VhtConfiguration ();
 
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
   static TypeId GetTypeId (void);
 
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/vht-operation.cc ns-3.31/src/wifi/model/vht-operation.cc
--- ns-3.30.1/src/wifi/model/vht-operation.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/vht-operation.cc	2020-06-27 17:38:30.000000000 -0700
@@ -38,15 +38,15 @@
 }
 
 void
-VhtOperation::SetVhtSupported (uint8_t vhtsupported)
+VhtOperation::SetVhtSupported (uint8_t vhtSupported)
 {
-  m_vhtSupported = vhtsupported;
+  m_vhtSupported = vhtSupported;
 }
 
 uint8_t
 VhtOperation::GetInformationFieldSize () const
 {
-  //we should not be here if vht is not supported
+  //we should not be here if VHT is not supported
   NS_ASSERT (m_vhtSupported > 0);
   return 5;
 }
@@ -161,14 +161,6 @@
   return length;
 }
 
-/**
- * output stream output operator
- *
- * \param os output stream
- * \param VhtOperation the VHT operation
- *
- * \returns output stream
- */
 std::ostream &
 operator << (std::ostream &os, const VhtOperation &VhtOperation)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/vht-operation.h ns-3.31/src/wifi/model/vht-operation.h
--- ns-3.30.1/src/wifi/model/vht-operation.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/vht-operation.h	2020-06-27 17:38:30.000000000 -0700
@@ -31,19 +31,30 @@
  *
  * This class knows how to serialise and deserialise
  * the VHT Operation Information Element
- *
- * \see attribute_VhtOperation
  */
 class VhtOperation : public WifiInformationElement
 {
 public:
   VhtOperation ();
+
+  // Implementations of pure virtual methods of WifiInformationElement
+  WifiInformationElementId ElementId () const;
+  uint8_t GetInformationFieldSize () const;
+  void SerializeInformationField (Buffer::Iterator start) const;
+  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length);
+  /* This information element is a bit special in that it is only
+     included if the STA is a VHT STA. To support this we
+     override the Serialize and GetSerializedSize methods of
+     WifiInformationElement. */
+  Buffer::Iterator Serialize (Buffer::Iterator start) const;
+  uint16_t GetSerializedSize () const;
+
   /**
    * Set the VHT supported information element.
    *
-   * \param vhtsupported the VHT supported information element
+   * \param vhtSupported the VHT supported information element
    */
-  void SetVhtSupported (uint8_t vhtsupported);
+  void SetVhtSupported (uint8_t vhtSupported);
 
   /**
    * Set the Channel Width field in the VHT Operation information element.
@@ -103,56 +114,12 @@
    */
   uint16_t GetBasicVhtMcsAndNssSet (void) const;
 
-  /**
-   * Return the element ID.
-   *
-   * \returns the element ID
-   */
-  WifiInformationElementId ElementId () const;
-  /**
-   * Return the information field size.
-   *
-   * \returns the information field size
-   */
-  uint8_t GetInformationFieldSize () const;
-  /**
-   * Serialize the information field.
-   *
-   * \param start the information field iterator
-   */
-  void SerializeInformationField (Buffer::Iterator start) const;
-  /**
-   * Deserialize the information field.
-   *
-   * \param start the iterator
-   * \param length the length
-   * \returns the information field size
-   */
-  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length);
-  /**
-   * This information element is a bit special in that it is only
-   * included if the STA is a VHT STA. To support this we
-   * override the Serialize and GetSerializedSize methods of
-   * WifiInformationElement.
-   *
-   * \param start
-   *
-   * \return an iterator
-   */
-  Buffer::Iterator Serialize (Buffer::Iterator start) const;
-  /**
-   * Return the serialized size of this VHT Operations IE.
-   *
-   * \return the serialized size of this VHT Operations IE
-   */
-  uint16_t GetSerializedSize () const;
-
 
 private:
   //VHT Operation Information
   uint8_t m_channelWidth; ///< channel width
   uint8_t m_channelCenterFrequencySegment0; ///< channel center frequency segment 0
-  uint8_t m_channelCenterFrequencySegment1; ///< channel center frequency segment 0
+  uint8_t m_channelCenterFrequencySegment1; ///< channel center frequency segment 1
 
   //Basic VHT-MCS and NSS Set
   uint16_t m_basicVhtMcsAndNssSet; ///< basic VHT MCS NSS set
@@ -161,6 +128,14 @@
   uint8_t m_vhtSupported;
 };
 
+/**
+ * output stream output operator
+ *
+ * \param os the output stream
+ * \param VhtOperation the VHT operation
+ *
+ * \returns output stream
+ */
 std::ostream &operator << (std::ostream &os, const VhtOperation &VhtOperation);
 
 } //namespace ns3
